#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3000four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 3000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3000four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four30004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four30004xi = {
                1:'1014x-1073y2611z',
                2:'1035x-367y2791z',
                3:'1058x-2756y528z',
                4:'1079x-320y2780z',
                5:'1088x-1037y2596z',
                6:'1095x-1605y2285z',
                7:'1107x-2061y1876z',
                8:'1122x-269y2769z',
                9:'1160x-995y2581z',
                10:'1161x-215y2757z',
                11:'1191x-1564y2265z',
                12:'1198x-158y2745z',
                13:'1203x-2702y499z',
                14:'1223x-2016y1853z',
                15:'1231x-949y2565z',
                16:'1232x-97y2733z',
                17:'1263x-33y2720z',
                18:'1286x-1517y2245z',
                19:'1300x-898y2549z',
                20:'1337x-1965y1829z',
                21:'1345x-2640y469z',
                22:'1367x-842y2534z',
                23:'1379x-1463y2225z',
                24:'1431x-781y2517z',
                25:'1449x-1906y1805z',
                26:'1470x-1405y2205z',
                27:'1483x-2569y439z',
                28:'1493x-716y2501z',
                29:'152x-2912y704z',
                30:'1551x-646y2484z',
                31:'1558x-1340y2185z',
                32:'1559x-1842y1781z',
                33:'1606x-573y2467z',
                34:'1618x-2492y410z',
                35:'1643x-1270y2164z',
                36:'1658x-495y2450z',
                37:'1665x-1770y1757z',
                38:'1705x-413y2433z',
                39:'1725x-1194y2143z',
                40:'1748x-328y2415z',
                41:'1749x-2407y380z',
                42:'1768x-1693y1733z',
                43:'1787x-239y2397z',
                44:'178x-136y2991z',
                45:'1803x-1114y2122z',
                46:'1821x-147y2379z',
                47:'1850x-52y2361z',
                48:'1868x-1609y1708z',
                49:'1875x-2315y350z',
                50:'1878x-1028y2101z',
                51:'1948x-937y2079z',
                52:'1963x-1520y1683z',
                53:'1995x-2216y320z',
                54:'2013x-842y2057z',
                55:'203x-575y2937z',
                56:'2053x-1424y1658z',
                57:'2074x-742y2036z',
                58:'209x-143y2989z',
                59:'2111x-2111y291z',
                60:'2129x-639y2013z',
                61:'2139x-1324y1633z',
                62:'2179x-531y1991z',
                63:'2220x-1218y1608z',
                64:'2220x-1999y261z',
                65:'2224x-420y1969z',
                66:'2262x-306y1946z',
                67:'2294x-188y1923z',
                68:'2295x-1107y1583z',
                69:'2320x-69y1900z',
                70:'2324x-1882y231z',
                71:'2364x-991y1557z',
                72:'2421x-1759y201z',
                73:'242x-147y2986z',
                74:'244x-591y2931z',
                75:'2508x-900y1583z',
                76:'2511x-1631y171z',
                77:'2595x-1498y141z',
                78:'2671x-1361y111z',
                79:'2739x-1219y81z',
                80:'276x-149y2983z',
                81:'2800x-1074y51z',
                82:'2853x-927y21z',
                83:'287x-603y2924z',
                84:'305x-2906y675z',
                85:'310x-147y2980z',
                86:'332x-613y2917z',
                87:'345x-142y2976z',
                88:'379x-620y2910z',
                89:'380x-133y2972z',
                90:'415x-122y2968z',
                91:'428x-623y2903z',
                92:'450x-107y2964z',
                93:'458x-2893y646z',
                94:'477x-623y2895z',
                95:'484x-88y2959z',
                96:'491x-1193y2708z',
                97:'517x-67y2954z',
                98:'528x-619y2887z',
                99:'549x-42y2948z',
                100:'564x-1190y2694z',
                101:'580x-14y2943z',
                102:'580x-611y2879z',
                103:'610x-2871y617z',
                104:'632x-600y2870z',
                105:'639x-1183y2681z',
                106:'684x-585y2861z',
                107:'714x-1171y2668z',
                108:'736x-565y2852z',
                109:'761x-2841y587z',
                110:'788x-542y2843z',
                111:'789x-1154y2654z',
                112:'800x-1694y2342z',
                113:'840x-515y2833z',
                114:'864x-1132y2640z',
                115:'891x-484y2823z',
                116:'899x-1670y2323z',
                117:'910x-2803y558z',
                118:'939x-1105y2625z',
                119:'940x-449y2813z',
                120:'988x-410y2802z',
                121:'997x-1641y2304z'}         
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3000four4xi" usage = "target function for charge30004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3000four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3000FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3000FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3000FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3000FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3000FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four30004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3000FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3000FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3000FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four30004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four30004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3000FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3000FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3000FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3000four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                    